// C Source File
// Created 5/29/2012; 8:07:55 PM

/*
Specifiaction:
+------+----|-----------
|Offset|Size|Description
|  0x00|0x01|Width.
|  0x01|0x01|Height.
|  0x02|   N|Pixel data (0=white, 1=light gray, 2=dark gray, 3=black)
*/

#include <tigcclib.h>

//start
const char* errors[]={"DMA Error","Failed to allocate memory","GrayOn Error","Could not set up grayscale","File I/O Error","Unable to open file","File does not exist","File Saved","File was successfully saved","Invalid file type","Image Error","Invalid image dimensions","Dialog Error","Unable to set up dialog","Cannot draw text","String is out of bounds"};
enum ErrCodes {DMA_ERROR,MEMALLOC_FAIL,GRAYON_ERROR,SETUPGRAY_FAIL,FILE_ERROR,FOPEN_FAIL,NO_FILE,FILE_SAVED,SAVE_SUCCESS,INVALID_TYPE,IMAGE_ERROR,INVALID_DIM,DLG_ERROR,DLGSETUP_FAIL,DRAWTXT_ERROR,STR_OOB};
enum Colors {WHITE,LGRAY,DGRAY,BLACK};
enum GAttrs {GA_DRAW,GA_ROT,GA_FLIP,GA_ADD};
enum Modes {M_NEW,M_OPEN};
#define GA_NORMAL GA_DRAW
#define GA_CYCLE GA_ROT
#define VERS 0.1
SCR_RECT* whole_scn=&(SCR_RECT){{0,0,239,127}};
INT_HANDLER I1=0,I5=0;
void delay(int a) //Creates a delay.
{
	short randNum;
	// generate random numbers to slow down the program...
	while (a-- > 0) {
	randNum = rand() % a;
	}
}
double sqr(double x)
{
	return x*x;
}
inline void dlgError(int title,int body)
{
	DlgMessage(errors[title],errors[body],BT_OK,BT_NONE);
}
inline void fileSaved(void)
{
	dlgError(FILE_SAVED,SAVE_SUCCESS);
}
inline void setUpBUB(void* buffer)
{
	PortSet(buffer,239,127);
}
inline int picsize(int w,int h)
{
	return ceil((float)(w*h)/4);
}
void* allocBUB(void)
{
	void* buffer=NULL;
	if ((buffer=malloc(LCD_SIZE))==NULL)
	{
		dlgError(DMA_ERROR,MEMALLOC_FAIL);
		return NULL;
	}
	return buffer;
}
int allocGBUB(void** lbuff,void** dbuff)
{
	*lbuff=allocBUB();
	if (!(*lbuff))
	{
		dlgError(DMA_ERROR,MEMALLOC_FAIL);
		return 0;
	}
	*dbuff=allocBUB();
	if (!(*dbuff))
	{
		dlgError(DMA_ERROR,MEMALLOC_FAIL);
		free(*lbuff);
		return 0;
	}
	return 1;
}
void GLCDSave(void* lbuff,void* dbuff)
{
	memcpy(lbuff,GrayGetPlane(LIGHT_PLANE),LCD_SIZE);
	memcpy(dbuff,GrayGetPlane(DARK_PLANE),LCD_SIZE);
}
void GLCDRestore(void* lbuff,void* dbuff)
{
	memcpy(GrayGetPlane(LIGHT_PLANE),lbuff,LCD_SIZE);
	memcpy(GrayGetPlane(DARK_PLANE),dbuff,LCD_SIZE);
}
short GetGPix(short x, short y)
{
	 GraySetAMSPlane(LIGHT_PLANE);
	 int color=GetPix(x,y);
	 GraySetAMSPlane(DARK_PLANE);
	 return color+2*GetPix(x,y);
}
void DrawGPix(short x, short y, short color, short attr)
{
	int col;
	if (attr)
	col=GetGPix(x,y);
	switch (attr)
	{
		case GA_DRAW:
		GraySetAMSPlane(LIGHT_PLANE);
		DrawPix(x,y,(color&1));
		GraySetAMSPlane(DARK_PLANE);
		DrawPix(x,y,(color&2)/2);
		break;
		case GA_ROT:
		DrawGPix(x,y,(col+color)%4,GA_DRAW);
		break;
		case GA_FLIP:
		DrawGPix(x,y,3-col,GA_DRAW);
	}
}
void DrawGLine(short x0, short y0, short x1, short y1, short color, short attr)
{
	if (attr==GA_ROT)
	{
		int d=sqrt(sqr(x1-x0)+sqr(y1-y0));
		float i;
		int x,y,a=0,b=0;
		for(i=0;i<=d;i+=.5)
		{
			x=(float)x0*(1-(float)i/(float)d)+(float)x1*((float)i/(float)d);
			y=(float)y0*(1-(float)i/(float)d)+(float)y1*((float)i/(float)d);
			if ((a!=x || b!=y)&&(x>=0&&y>=0&&y<whole_scn->xy.y1&&x<whole_scn->xy.x1)) DrawGPix(x,y,color,GA_ROT);
			a=x;
			b=y;
		}
	}
	else
	{
		WIN_RECT line={x0,y0,x1,y1};
		switch (attr)
		{
			case GA_ADD:
			GraySetAMSPlane(LIGHT_PLANE);
			if (color&1) DrawClipLine(&line,whole_scn,A_NORMAL);
			GraySetAMSPlane(DARK_PLANE);
			if (color&2) DrawClipLine(&line,whole_scn,A_NORMAL);
			break;
			default:
			GraySetAMSPlane(LIGHT_PLANE);
			DrawClipLine(&line,whole_scn,attr?A_XOR:(color&1));
			GraySetAMSPlane(DARK_PLANE);
			DrawClipLine(&line,whole_scn,attr?A_XOR:(color&2)/2);
		}
	}
}
void DrawGTriangle(short x0, short y0, short x1, short y1, short x2, short y2, short color, short attr)
{
	DrawGLine(x0,y0,x1,y1,color,attr);
	DrawGLine(x2,y2,x1,y1,color,attr);
	DrawGLine(x0,y0,x2,y2,color,attr);
}
void DrawGTriangleFill(short x0, short y0, short x1, short y1, short x2, short y2, short color, short attr)
{
	switch (attr)
	{
		case GA_DRAW:
		GraySetAMSPlane(LIGHT_PLANE);
		FillTriangle(x0,y0,x1,y1,x2,y2,whole_scn,(color&1));
		GraySetAMSPlane(DARK_PLANE);
		FillTriangle(x0,y0,x1,y1,x2,y2,whole_scn,(color&2)/2);
		break;
		case GA_ROT:
		case GA_ADD:
		GraySetAMSPlane(LIGHT_PLANE);
		if (color&1) FillTriangle(x0,y0,x1,y1,x2,y2,whole_scn,A_NORMAL);
		GraySetAMSPlane(DARK_PLANE);
		if (color&2) FillTriangle(x0,y0,x1,y1,x2,y2,whole_scn,A_NORMAL);
		break;
		case GA_FLIP:
		GraySetAMSPlane(LIGHT_PLANE);
		FillTriangle(x0,y0,x1,y1,x2,y2,whole_scn,A_XOR);
		GraySetAMSPlane(DARK_PLANE);
		FillTriangle(x0,y0,x1,y1,x2,y2,whole_scn,A_XOR);
		break;
	}
}
void DrawGRect(short x0, short y0, short x1, short y1, short color, short attr)
{
	DrawGLine(x0,y0,x1,y0,color,attr);
	DrawGLine(x0,y0,x0,y1,color,attr);
	DrawGLine(x1,y0,x1,y1,color,attr);
	DrawGLine(x0,y1,x1,y1,color,attr);
}
void DrawGRectFill(short x0, short y0, short x1, short y1, short color, short attr)
{
	if (attr==GA_ROT)
	{
		int i;
		if (x1>x0)
		{
			for(i=x0;i<=x1;i++)
			{
				DrawGLine(i,y0,i,y1,color,attr);
			}
		}
		else
		{
			for(i=x1;i>=x0;i--)
			{
				DrawGLine(i,y0,i,y1,color,attr);
			}
		}
	}
	else
	{
		SCR_RECT rect={{x0,y0,x1,y1}};
		switch (attr)
		{
			case GA_ADD:
			GraySetAMSPlane(LIGHT_PLANE);
			if (color&1) ScrRectFill(&rect,whole_scn,A_NORMAL);
			GraySetAMSPlane(DARK_PLANE);
			if (color&2) ScrRectFill(&rect,whole_scn,A_NORMAL);
			break;
			default:
			GraySetAMSPlane(LIGHT_PLANE);
			ScrRectFill(&rect,whole_scn,attr?A_XOR:(color&1));
			GraySetAMSPlane(DARK_PLANE);
			ScrRectFill(&rect,whole_scn,attr?A_XOR:(color&2)/2);
		}
	}
}
void DrawGEllipse(short x0, short y0, short x1, short y1, short color, short attr)
{
	int xc,yc,a,b;
	xc=(x0+x1)/2;
	yc=(y0+y1)/2;
	a=abs(x1-xc);
	b=abs(y1-yc);
	switch (attr)
	{
		case GA_DRAW:
		GraySetAMSPlane(LIGHT_PLANE);
		DrawClipEllipse(xc,yc,a,b,whole_scn,color&1);
		GraySetAMSPlane(DARK_PLANE);
		DrawClipEllipse(xc,yc,a,b,whole_scn,(color&2)/2);
		break;
		case GA_ROT:
		case GA_ADD:
		GraySetAMSPlane(LIGHT_PLANE);
		if (color&1) DrawClipEllipse(xc,yc,a,b,whole_scn,A_NORMAL);
		GraySetAMSPlane(DARK_PLANE);
		if (color&2) DrawClipEllipse(xc,yc,a,b,whole_scn,A_NORMAL);
		break;
		case GA_FLIP:
		GraySetAMSPlane(LIGHT_PLANE);
		DrawClipEllipse(xc,yc,a,b,whole_scn,A_XOR);
		GraySetAMSPlane(DARK_PLANE);
		DrawClipEllipse(xc,yc,a,b,whole_scn,A_XOR);
	}
}
void DrawGEllipseFill(short x0, short y0, short x1, short y1, short color, short attr)
{
	double i;
	double h;
	double xc=(x0+x1)/2,yc=(y0+y1)/2;
	double a=abs(xc-x0);
	double b=abs(yc-y0);
	if (x1>x0)
	{
		for(i=x0;i<=x1;i++)
		{
			h=b*sqrt(1-(sqr(i-xc)/sqr(a)));
			DrawGLine(i,yc-h,i,yc+h,color,attr);
		}
	}
	else
	{
		for(i=x0;i>=x1;i--)
		{
			h=b*sqrt(1-(sqr(i-xc)/sqr(a)));
			DrawGLine(i,yc-h,i,yc+h,color,attr);
		}
	}
}
void DrawGCirc(short x,short y, short r, short color, short attr)
{
	DrawGEllipse(x-r,y-r,x+r,y+r,color,attr);
}
void DrawGCircFill(short x,short y, short r, short color, short attr)
{
	DrawGEllipseFill(x-r,y-r,x+r,y+r,color,attr);
}
void DrawGStr(short x0, short y0, const char* string, short color, short attr)
{
	switch (attr)
	{
		case GA_DRAW:
		GraySetAMSPlane(LIGHT_PLANE);
		DrawStr(x0,y0,string,(color&1));
		GraySetAMSPlane(DARK_PLANE);
		DrawStr(x0,y0,string,(color&2)/2);
		break;
		case GA_ROT:
		GraySetAMSPlane(LIGHT_PLANE);
		if (color&1) DrawStr(x0,y0,string,A_NORMAL);
		GraySetAMSPlane(DARK_PLANE);
		if (color&2) DrawStr(x0,y0,string,A_NORMAL);
		break;
		case GA_FLIP:
		GraySetAMSPlane(LIGHT_PLANE);
		DrawStr(x0,y0,string,A_XOR);
		GraySetAMSPlane(DARK_PLANE);
		DrawStr(x0,y0,string,A_XOR);
	}
}
void ClrScrAll(void)
{
	memset(GrayGetPlane(0),0,LCD_SIZE);
	memset(GrayGetPlane(1),0,LCD_SIZE);
}
//save as KPIC
short SaveKPIC(char* fname,unsigned int w,unsigned int h,void* lbuff,void* dbuff)
{
	FILE* f=fopen(fname,"wb");
	if (!f)
	{
		GLCDSave(lbuff,dbuff);
		GrayOff();
		SetIntVec(AUTO_INT_1,I1);
		SetIntVec(AUTO_INT_5,I5);
		dlgError(FILE_ERROR,FOPEN_FAIL);
		SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
		SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
		GrayOn();
		GLCDRestore(lbuff,dbuff);
		return 0;
	}
	int i,bytes=picsize(w,h);
	int x=0,y=0,mm;
	fputc(w,f);
	fputc(h,f);
	for (i=0;i<bytes;i++)
	{
		mm=64*GetGPix(x,y);
		x++;
		if (x>=w)
		{
			y++;
			x=0;
		}
		mm+=16*GetGPix(x,y);
		x++;
		if (x>=w)
		{
			y++;
			x=0;
		}
		mm+=4*GetGPix(x,y);
		x++;
		if (x>=w)
		{
			y++;
			x=0;
		}
		fputc(mm+GetGPix(x,y),f);
		x++;
		if (x>=w)
		{
			y++;
			x=0;
		}
	}
	fputc(0,f);
	fputs("KPIC",f);
	fputc(0,f);
	fputc(OTH_TAG,f);
	fclose(f);
	return 1;
}
short SavePIC(const char* fname)
{
	GraySetAMSPlane(DARK_PLANE);
	char* buff=NULL;
	if (!(buff=malloc(BitmapSize(whole_scn)))) return 0;
	BitmapGet(whole_scn,buff);
	FILE* f=fopen(fname,"wb");
	fwrite(buff,BitmapSize(whole_scn),1,f);
	int i;
	for(i=0;i<9;i++) fputc(0,f);
	fputc(PIC_TAG,f);
	fclose(f);
	free(buff);
}
short OpenKPIC(const char* fname,int* wl,int* hl)
{
	FILE* f=fopen(fname,"rb");
	if (!f)
	{
		return 0;
	}
	unsigned char w=fgetc(f);
	unsigned char h=fgetc(f);
	int i,bytes=picsize(w,h);
	int x=0,y=0,mm,col;
	for (i=0;i<bytes;i++)
	{
		mm=fgetc(f);
		col=(mm&0b11000000)>>6;
		DrawGPix(x,y,col,GA_DRAW);
		x++;
		if (x>=w)
		{
			y++;
			x=0;
		}
		col=(mm&0b00110000)>>4;
		DrawGPix(x,y,col,GA_DRAW);
		x++;
		if (x>=w)
		{
			y++;
			x=0;
		}
		col=(mm&0b00001100)>>2;
		DrawGPix(x,y,col,GA_DRAW);
		x++;
		if (x>=w)
		{
			y++;
			x=0;
		}
		col=mm&0b00000011;
		DrawGPix(x,y,col,GA_DRAW);
		x++;
		if (x>=w)
		{
			y++;
			x=0;
		}
	}
	fclose(f);
	*wl=w;
	*hl=h;
	return 1;
}
int requestName(char* fname,short* typeID,void* lbuff,void* dbuff)
{
	GLCDSave(lbuff,dbuff);
	*typeID=1;
	GrayOff();
	SetIntVec(AUTO_INT_1,I1);
	SetIntVec(AUTO_INT_5,I5);
	HANDLE h=DialogNewSimple(100,40);
	if (!h)
	{
		dlgError(DLG_ERROR,DLGSETUP_FAIL);
		return 0;
	}
	DialogAddTitle(h,"Kraphyko",BT_OK,BT_NONE);
	DialogAddRequest(h,7,12,"File name?",0,9,9);
	HANDLE p=PopupNew("File Type",0);
	if (!p)
	{
		dlgError(DLG_ERROR,DLGSETUP_FAIL);
		HeapFree(h);
		return 0;
	}
	PopupAddText(p,-1,"Kraphyko Pic (.KPIC)",1);
	PopupAddText(p,-1,"TIOS Pic (.PIC)",2);
	DialogAddPulldown(h,7,20,"File Type:",p,0);
	DialogDo(h,CENTER,CENTER,fname,typeID);
	HeapFree(h);
	HeapFree(p);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
	GrayOn();
	GLCDRestore(lbuff,dbuff);
	return 1;
}
void drawCursor(int x,int y) //Draws the cursor
{
	unsigned char cursorl[8] = {
		0x80,0xC0,0xA0,0x90,0xB8,0xE0,0x90,0x08
	};
	unsigned char cursord[8] = {
		0x80,0xC0,0xE0,0xF0,0xF8,0xE0,0x90,0x08
	};
	unsigned char cursorm[8] = {
		0x7F,0x3F,0x1F,0x0F,0x07,0x1F,0x6F,0xF7
	};
	Sprite8(x,y,8,cursorm,GrayGetPlane(LIGHT_PLANE),SPRT_AND);
	Sprite8(x,y,8,cursorm,GrayGetPlane(DARK_PLANE),SPRT_AND);
	Sprite8(x,y,8,cursorl,GrayGetPlane(LIGHT_PLANE),SPRT_OR);
	Sprite8(x,y,8,cursord,GrayGetPlane(DARK_PLANE),SPRT_OR);
}
int moveCursor(int* xp,int* yp,void* lbuff,void* dbuff,int w,int h)
{
	GKeyFlush();
	int x=*xp,y=*yp;
	int k;
	do
	{
		GLCDSave(lbuff,dbuff);
		drawCursor(x,y);
		k=_rowread(~0x0001);
		x=x-(k&2&&x!=0)+(k&8&&x!=w-1);
		y=y-(k&1&&y!=0)+(k&4&&y!=h-1);
		delay(900);
		GLCDRestore(lbuff,dbuff);
		if (_rowread(~0x40)) return 0;
		k=_rowread(~0x0002);
	} while (!(k&129));
	*xp=x;
	*yp=y;
	delay(1500);
	return 1;
}
void Pencil(int* xp,int* yp,void* lbuff,void* dbuff,int w,int h,int col)
{
	GKeyFlush();
	int x=*xp,y=*yp;
	int k;
	do
	{
		GLCDSave(lbuff,dbuff);
		drawCursor(x,y);
		k=_rowread(~0x0001);
		x=x-(k&2&&x!=0)+(k&8&&x!=w-1);
		y=y-(k&1&&y!=0)+(k&4&&y!=h-1);
		delay(900);
		GLCDRestore(lbuff,dbuff);
		if (k&0xF0)
		DrawGPix(x,y,col,GA_NORMAL+!!(k&96)+!!(k&64));
		k=_rowread(~0x0002);
	} while (!(k&129));
}
void updateSettings(int* col,int* attr,int*fontsize,int*filled,void* lbuff,void*dbuff)
{
	GLCDSave(lbuff,dbuff);
	int i,n=0,k;
	const char* attrStrings[4]={"Normal","Rotate","Flip","Add"};
	const char* yesOrNo[2]={"No","Yes"};
	const char* fontSizes[3]={"Small","Normal","Large"};
	for(i=0;i<2;i++)
	{
		GraySetAMSPlane(i);
		ClrScr();
		FontSetSys(F_6x8);
		DrawStr(0,0,"Kraphyko 0.5 \200",A_NORMAL);
		DrawPix(56,4,A_NORMAL);
		DrawPix(58,2,A_NORMAL);
		DrawLine(0,8,159,8,A_NORMAL);
		FontSetSys(F_4x6);
		DrawStr(5,10,"Color: ",A_NORMAL);
		DrawStr(5,16,"Attribute: ",A_NORMAL);
		DrawStr(5,22,"Filled: ",A_NORMAL);
		DrawStr(5,28,"Font Size: ",A_NORMAL);
		DrawStr(39,16,attrStrings[*attr],A_XOR);
		DrawStr(28,22,yesOrNo[*filled],A_XOR);
		DrawStr(39,28,fontSizes[*fontsize],A_XOR);
	}
	DrawGRectFill(24,10,30,15,*col,GA_DRAW);
	DrawChar(1,10,'>',A_XOR);
	do {
		k=_rowread(~0x0001);
		DrawChar(1,10+6*n,'>',A_XOR);
		n=n-(k&1)+!!(k&4);
		if (n==-1) n=3;
		if (n==4) n=0;
		DrawChar(1,10+6*n,'>',A_XOR);
		if (k&8)
		{
			switch (n)
			{
				case 0:
				*col=(*col+1)%4;
				DrawGRectFill(24,10,30,15,*col,GA_DRAW);
				break;
				case 1:
				DrawGStr(39,16,attrStrings[*attr],3,GA_FLIP);
				*attr=(*attr+1)%4;
				DrawGStr(39,16,attrStrings[*attr],3,GA_FLIP);
				break;
				case 2:
				DrawGStr(28,22,yesOrNo[*filled],3,GA_FLIP);
				*filled=!(*filled);
				DrawGStr(28,22,yesOrNo[*filled],3,GA_FLIP);
				break;
				case 3:
				DrawGStr(39,28,fontSizes[*fontsize],3,GA_FLIP);
				*fontsize=(*fontsize+1)%3;
				DrawGStr(39,28,fontSizes[*fontsize],3,GA_FLIP);
			}
		}
		delay(2700);
		k=_rowread(~0x0002);
	}while (!(k&1));
	GLCDRestore(lbuff,dbuff);
}
int MenuScn(void* lbuff, void* dbuff,int w,int h,char* fname)
{
	GLCDSave(lbuff,dbuff);
	char buff[20];
	sprintf(buff,"%dX%d",w,h);
	int i;
	for(i=0;i<2;i++)
	{
		GraySetAMSPlane(i);
		ClrScr();
		FontSetSys(F_6x8);
		DrawStr(0,0,"Kraphyko 0.5 \200",A_NORMAL);
		DrawPix(56,4,A_NORMAL);
		DrawPix(58,2,A_NORMAL);
		DrawLine(0,8,159,8,A_NORMAL);
		FontSetSys(F_4x6);
		DrawStr(5,10,"Pencil",A_NORMAL);
		DrawStr(5,16,"Line",A_NORMAL);
		DrawStr(5,22,"Rectangle",A_NORMAL);
		DrawStr(5,28,"Circle",A_NORMAL);
		DrawStr(5,34,"Ellipse",A_NORMAL);
		DrawStr(5,40,"Triangle",A_NORMAL);
		DrawStr(5,46,"Text",A_NORMAL);
		DrawStr(5,52,"Set Color/Attrs",A_NORMAL);
		DrawStr(5,58,"Clear",A_NORMAL);
		DrawStr(5,64,"Save",A_NORMAL);
		DrawStr(5,70,"Save As",A_NORMAL);
		DrawStr(5,76,"Quit",A_NORMAL);
		DrawStr(5,82,"Help",A_NORMAL);
		DrawStr(100,10,fname,A_NORMAL);
		DrawStr(100,16,buff,A_NORMAL);
	}
	DrawChar(1,10,'>',A_NORMAL);
	int k,n=0;
	do {
		k=_rowread(~0x0001);
		DrawChar(1,10+6*n,'>',A_XOR);
		n=n-(k&1)+!!(k&4);
		if (n==-1) n=12;
		if (n==13) n=0;
		DrawChar(1,10+6*n,'>',A_XOR);
		delay(2700);
		if (_rowread(~0x40)) return 11;
		k=_rowread(~0x0002);
	} while (!(k&1));
	GLCDRestore(lbuff,dbuff);
	return n;
}
void EditImg(int mode,char* fname,void* lbuff,void* dbuff,int w,int h,int ftype)
{
	ClrScrAll();
	if (mode==M_OPEN)
	{
		OpenKPIC(fname,&w,&h);
	}
	whole_scn->xy.x1=w-1;
	whole_scn->xy.y1=h-1;
	
	int done=0,n;
	int x=0,y=0,col=3,a=0,b=0,c=0,d=0,attr=0,fontsize=1,filled=0,r=0;
	char shadow[9];
	while (!done)
	{
		n=MenuScn(lbuff,dbuff,w,h,fname);
		delay(1500);
		done=n==11;
		switch (n)
		{
			case 0:
			Pencil(&x,&y,lbuff,dbuff,w,h,col);
			break;
			case 1:
			if (!moveCursor(&a,&b,lbuff,dbuff,w,h)) break;
			if (!moveCursor(&x,&y,lbuff,dbuff,w,h)) break;
			DrawGLine(x,y,a,b,col,attr);
			break;
			case 2:
			if (!moveCursor(&a,&b,lbuff,dbuff,w,h)) break;
			if (!moveCursor(&x,&y,lbuff,dbuff,w,h)) break;
			if (filled) DrawGRectFill(x,y,a,b,col,attr);
			else DrawGRect(x,y,a,b,col,attr);
			break;
			case 3:
			if (!moveCursor(&x,&y,lbuff,dbuff,w,h)) break;
			if (!moveCursor(&a,&b,lbuff,dbuff,w,h)) break;
			r=sqrt(sqr(a-x)+sqr(b-y));
			if (filled) DrawGCircFill(x,y,r,col,attr);
			else DrawGCirc(x,y,r,col,attr);
			break;
			case 4:
			if (!moveCursor(&a,&b,lbuff,dbuff,w,h)) break;
			if (!moveCursor(&x,&y,lbuff,dbuff,w,h)) break;
			if (filled) DrawGEllipseFill(x,y,a,b,col,attr);
			else DrawGEllipse(x,y,a,b,col,attr);
			break;
			case 5:
			if (!moveCursor(&a,&b,lbuff,dbuff,w,h)) break;
			if (!moveCursor(&c,&d,lbuff,dbuff,w,h)) break;
			if (!moveCursor(&x,&y,lbuff,dbuff,w,h)) break;
			if (filled) DrawGTriangleFill(x,y,a,b,c,d,col,attr);
			else DrawGTriangle(x,y,a,b,c,d,col,attr);
			break;
			case 6:
			if (!moveCursor(&x,&y,lbuff,dbuff,w,h)) break;
			GLCDSave(lbuff,dbuff);
			r=1;
			GrayOff();
			SetIntVec(AUTO_INT_1,I1);
			SetIntVec(AUTO_INT_5,I5);
			HANDLE hn=H_NULL;
			char* buff=NULL;
			if (!(buff=malloc(100))) break;
			if (!(hn=DialogNewSimple(150,90)))
			{free(buff); break;}
			DialogAddTitle(hn,"Kraphyko",BT_OK,BT_NONE);
			DialogAddRequest(hn,7,12,"String to Draw:",0,99,20);
			DialogDo(hn,CENTER,CENTER,buff,NULL);
			HeapFree(hn);
			FontSetSys(fontsize);
			if ((x+DrawStrWidth(buff,fontsize))>w)
			{dlgError(DRAWTXT_ERROR,STR_OOB);r=0;}
			SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
			SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
			GrayOn();
			GLCDRestore(lbuff,dbuff);
			if (r) DrawGStr(x,y,buff,col,attr);
			free(buff);
			break;
			case 7:
			updateSettings(&col,&attr,&fontsize,&filled,lbuff,dbuff);
			break;
			case 8:
			ClrScrAll();
			break;
			case 10:
			strcpy(shadow,fname);
			requestName(fname,&ftype,lbuff,dbuff);
			case 9:
			if (ftype==1) SaveKPIC(fname,w,h,lbuff,dbuff);
			else {SavePIC(fname);
			strcpy(fname,shadow);}
			strcpy(shadow,"\0");
		}
		delay(1500);
	}
}
//end

// Main Function
void _main(void)
{
	// Place your code here.
	I1=GetIntVec(AUTO_INT_1);
	I5=GetIntVec(AUTO_INT_5);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
	char fname[9];
	void* lbuff=NULL,* dbuff=NULL;
	if (!allocGBUB(&lbuff,&dbuff))
	return;
	if (!GrayOn())
	{
		free(lbuff);
		free(dbuff);
		return;
	}
	EditImg(M_OPEN,(char*)"sample",lbuff,dbuff,64,64,1);
	GrayOff();
	free(lbuff);
	free(dbuff);
	SetIntVec(AUTO_INT_1,I1);
	SetIntVec(AUTO_INT_5,I5);
}
